import 'dart:convert';

import 'package:iop_sdk/crypto.dart';
import 'package:iop_sdk/ssi.dart';

void main() {
  final unlockPassword = 'unlock';
  final vault = Vault.create(Bip39.DEMO_PHRASE, '', unlockPassword);

  MorpheusPlugin.init(vault, unlockPassword);
  final morpheusPlugin = MorpheusPlugin.get(vault);
  final morpheusPrivate = morpheusPlugin.private(unlockPassword);
  //final privateKey = morpheusPrivate.personas.key(2).privateKey();
  final did = morpheusPrivate.personas.did(2);
  //expect(did.toString(), 'did:morpheus:ezqztJ6XX6GDxdSgdiySiT3J');
  final id = did.defaultKeyId();
  //expect(id.toString(), 'iezqztJ6XX6GDxdSgdiySiT3J');

  final didData = DidData(did.toString());
  final claimString =
'''{
  "address": "6 Unter den Linden, Berlin, Germany",
  "dateOfBirth": "16/02/2002",
  "placeOfBirth": {
    "city": "Berlin",
    "country": "Germany"
  }
}''';
  final evidenceString = '{"banana":{}}';
  final claim = Claim(
    didData,
    Content<DynamicContent>.fromJson(json.decode(claimString)),
  );
  final claimant = KeyLink('#2');
  final evidence = Content<DynamicContent>.fromJson(
    json.decode(evidenceString),
  );
  final nonce = nonce264();
  final request = WitnessRequest(
    claim,
    claimant,
    ContentId('cjuKyGjvyUZuD2A69oH7i4FyHT_TXH9ss022yDazJl2vF8'),
    evidence,
    nonce,
  );

  final signedWitnessRequest = morpheusPrivate.signWitnessRequest(id, request);
  print(json.encode(signedWitnessRequest));
}
